import { Client as Postgres } from 'pg';
export declare type Coercer = (value: {
    intValue: number;
    stringValue: string;
    bigIntValue: number;
    longValue: number;
    booleanValue: boolean;
} & {
    [key: string]: any;
}) => number | string | boolean;
declare type EscapeFunction = (source: string) => string;
declare type FullJitter = (retries: number) => number;
export declare type AdapterPool = {
    config: {
        user?: string;
        database?: any;
        port?: number;
        host?: string;
        password?: string;
        databaseName?: string;
        eventsTableName?: string;
        snapshotsTableName?: string;
        secretsTableName?: string;
    };
    maybeThrowResourceError: (error: Error[]) => void;
    coerceEmptyString: (obj: any, fallback?: string) => string;
    Postgres: typeof Postgres;
    connectionOptions: any;
    databaseName: string;
    eventsTableName: string;
    snapshotsTableName: string;
    secretsTableName: string;
    fullJitter: FullJitter;
    coercer: Coercer;
    executeStatement: (sql: string) => Promise<any[]>;
    escapeId: EscapeFunction;
    escape: EscapeFunction;
    shapeEvent: (event: any, additionalFields?: any) => any[];
};
export declare type AdapterSpecific = {
    Postgres: typeof Postgres;
    fullJitter: FullJitter;
    escapeId: EscapeFunction;
    escape: EscapeFunction;
    executeStatement: (pool: AdapterPool, sql: string) => Promise<any[]>;
    coercer: Coercer;
};
export {};
